// +build !ignore_autogenerated

/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by deepcopy-gen. DO NOT EDIT.

package v1

import (
	runtime "k8s.io/apimachinery/pkg/runtime"
)

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Cert) DeepCopyInto(out *Cert) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Cert.
func (in *Cert) DeepCopy() *Cert {
	if in == nil {
		return nil
	}
	out := new(Cert)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Client) DeepCopyInto(out *Client) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Client.
func (in *Client) DeepCopy() *Client {
	if in == nil {
		return nil
	}
	out := new(Client)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Code) DeepCopyInto(out *Code) {
	*out = *in
	in.Image.DeepCopyInto(&out.Image)
	if in.Entrypoint != nil {
		in, out := &in.Entrypoint, &out.Entrypoint
		*out = new([]string)
		if **in != nil {
			in, out := *in, *out
			*out = make([]string, len(*in))
			copy(*out, *in)
		}
	}
	if in.Mapping != nil {
		in, out := &in.Mapping, &out.Mapping
		*out = new(Mapping)
		(*in).DeepCopyInto(*out)
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Code.
func (in *Code) DeepCopy() *Code {
	if in == nil {
		return nil
	}
	out := new(Code)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Component) DeepCopyInto(out *Component) {
	*out = *in
	in.Element.DeepCopyInto(&out.Element)
	in.Description.DeepCopyInto(&out.Description)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Component.
func (in *Component) DeepCopy() *Component {
	if in == nil {
		return nil
	}
	out := new(Component)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ComponentDescription) DeepCopyInto(out *ComponentDescription) {
	*out = *in
	in.Config.DeepCopyInto(&out.Config)
	in.Srv.DeepCopyInto(&out.Srv)
	out.Size = in.Size
	out.Profile = in.Profile
	if in.Codes != nil {
		in, out := &in.Codes, &out.Codes
		*out = make(map[string]Code, len(*in))
		for key, val := range *in {
			(*out)[key] = *val.DeepCopy()
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ComponentDescription.
func (in *ComponentDescription) DeepCopy() *ComponentDescription {
	if in == nil {
		return nil
	}
	out := new(ComponentDescription)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ComponentSize) DeepCopyInto(out *ComponentSize) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ComponentSize.
func (in *ComponentSize) DeepCopy() *ComponentSize {
	if in == nil {
		return nil
	}
	out := new(ComponentSize)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Config) DeepCopyInto(out *Config) {
	*out = *in
	if in.Parameters != nil {
		in, out := &in.Parameters, &out.Parameters
		*out = new(map[string]runtime.RawExtension)
		if **in != nil {
			in, out := *in, *out
			*out = make(map[string]runtime.RawExtension, len(*in))
			for key, val := range *in {
				(*out)[key] = *val.DeepCopy()
			}
		}
	}
	if in.Resource != nil {
		in, out := &in.Resource, &out.Resource
		*out = new(map[string]runtime.RawExtension)
		if **in != nil {
			in, out := *in, *out
			*out = make(map[string]runtime.RawExtension, len(*in))
			for key, val := range *in {
				(*out)[key] = *val.DeepCopy()
			}
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Config.
func (in *Config) DeepCopy() *Config {
	if in == nil {
		return nil
	}
	out := new(Config)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *DeploymentDescription) DeepCopyInto(out *DeploymentDescription) {
	*out = *in
	in.Service.DeepCopyInto(&out.Service)
	if in.Qos != nil {
		in, out := &in.Qos, &out.Qos
		*out = new(Qos)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new DeploymentDescription.
func (in *DeploymentDescription) DeepCopy() *DeploymentDescription {
	if in == nil {
		return nil
	}
	out := new(DeploymentDescription)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *DeploymentSpec) DeepCopyInto(out *DeploymentSpec) {
	*out = *in
	in.Element.DeepCopyInto(&out.Element)
	in.Description.DeepCopyInto(&out.Description)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new DeploymentSpec.
func (in *DeploymentSpec) DeepCopy() *DeploymentSpec {
	if in == nil {
		return nil
	}
	out := new(DeploymentSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Duplex) DeepCopyInto(out *Duplex) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Duplex.
func (in *Duplex) DeepCopy() *Duplex {
	if in == nil {
		return nil
	}
	out := new(Duplex)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Element) DeepCopyInto(out *Element) {
	*out = *in
	in.Ref.DeepCopyInto(&out.Ref)
	if in.Scope != nil {
		in, out := &in.Scope, &out.Scope
		*out = new(Scope)
		if **in != nil {
			in, out := *in, *out
			*out = make([]ScopeElement, len(*in))
			copy(*out, *in)
		}
	}
	if in.Spec != nil {
		in, out := &in.Spec, &out.Spec
		*out = make(Version, len(*in))
		copy(*out, *in)
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Element.
func (in *Element) DeepCopy() *Element {
	if in == nil {
		return nil
	}
	out := new(Element)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *EnvItem) DeepCopyInto(out *EnvItem) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new EnvItem.
func (in *EnvItem) DeepCopy() *EnvItem {
	if in == nil {
		return nil
	}
	out := new(EnvItem)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *FileSystemItem) DeepCopyInto(out *FileSystemItem) {
	*out = *in
	if in.Data != nil {
		in, out := &in.Data, &out.Data
		*out = new(runtime.RawExtension)
		(*in).DeepCopyInto(*out)
	}
	if in.Format != nil {
		in, out := &in.Format, &out.Format
		*out = new(string)
		**out = **in
	}
	if in.Perms != nil {
		in, out := &in.Perms, &out.Perms
		*out = new(Permissions)
		(*in).DeepCopyInto(*out)
	}
	if in.Size != nil {
		in, out := &in.Size, &out.Size
		*out = new(int32)
		**out = **in
	}
	if in.Unit != nil {
		in, out := &in.Unit, &out.Unit
		*out = new(string)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new FileSystemItem.
func (in *FileSystemItem) DeepCopy() *FileSystemItem {
	if in == nil {
		return nil
	}
	out := new(FileSystemItem)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Hub) DeepCopyInto(out *Hub) {
	*out = *in
	if in.Secret != nil {
		in, out := &in.Secret, &out.Secret
		*out = new(string)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Hub.
func (in *Hub) DeepCopy() *Hub {
	if in == nil {
		return nil
	}
	out := new(Hub)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Image) DeepCopyInto(out *Image) {
	*out = *in
	if in.Hub != nil {
		in, out := &in.Hub, &out.Hub
		*out = new(Hub)
		(*in).DeepCopyInto(*out)
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Image.
func (in *Image) DeepCopy() *Image {
	if in == nil {
		return nil
	}
	out := new(Image)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuCN) DeepCopyInto(out *KukuCN) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	out.Spec = in.Spec
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuCN.
func (in *KukuCN) DeepCopy() *KukuCN {
	if in == nil {
		return nil
	}
	out := new(KukuCN)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KukuCN) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuCNList) DeepCopyInto(out *KukuCNList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]KukuCN, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuCNList.
func (in *KukuCNList) DeepCopy() *KukuCNList {
	if in == nil {
		return nil
	}
	out := new(KukuCNList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KukuCNList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuCNSpec) DeepCopyInto(out *KukuCNSpec) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuCNSpec.
func (in *KukuCNSpec) DeepCopy() *KukuCNSpec {
	if in == nil {
		return nil
	}
	out := new(KukuCNSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuCert) DeepCopyInto(out *KukuCert) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Data.DeepCopyInto(&out.Data)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuCert.
func (in *KukuCert) DeepCopy() *KukuCert {
	if in == nil {
		return nil
	}
	out := new(KukuCert)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KukuCert) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuCertData) DeepCopyInto(out *KukuCertData) {
	*out = *in
	if in.Cert != nil {
		in, out := &in.Cert, &out.Cert
		*out = make([]byte, len(*in))
		copy(*out, *in)
	}
	if in.Key != nil {
		in, out := &in.Key, &out.Key
		*out = make([]byte, len(*in))
		copy(*out, *in)
	}
	if in.Ca != nil {
		in, out := &in.Ca, &out.Ca
		*out = new([]byte)
		if **in != nil {
			in, out := *in, *out
			*out = make([]byte, len(*in))
			copy(*out, *in)
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuCertData.
func (in *KukuCertData) DeepCopy() *KukuCertData {
	if in == nil {
		return nil
	}
	out := new(KukuCertData)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuCertList) DeepCopyInto(out *KukuCertList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]KukuCert, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuCertList.
func (in *KukuCertList) DeepCopy() *KukuCertList {
	if in == nil {
		return nil
	}
	out := new(KukuCertList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KukuCertList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuComponent) DeepCopyInto(out *KukuComponent) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuComponent.
func (in *KukuComponent) DeepCopy() *KukuComponent {
	if in == nil {
		return nil
	}
	out := new(KukuComponent)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KukuComponent) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuComponentList) DeepCopyInto(out *KukuComponentList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]KukuComponent, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuComponentList.
func (in *KukuComponentList) DeepCopy() *KukuComponentList {
	if in == nil {
		return nil
	}
	out := new(KukuComponentList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KukuComponentList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuComponentSpec) DeepCopyInto(out *KukuComponentSpec) {
	*out = *in
	in.Channels.DeepCopyInto(&out.Channels)
	if in.Configuration != nil {
		in, out := &in.Configuration, &out.Configuration
		*out = new(KumoriConfigurationDescription)
		(*in).DeepCopyInto(*out)
	}
	if in.Containers != nil {
		in, out := &in.Containers, &out.Containers
		*out = make([]KumoriContainer, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuComponentSpec.
func (in *KukuComponentSpec) DeepCopy() *KukuComponentSpec {
	if in == nil {
		return nil
	}
	out := new(KukuComponentSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuDeployment) DeepCopyInto(out *KukuDeployment) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuDeployment.
func (in *KukuDeployment) DeepCopy() *KukuDeployment {
	if in == nil {
		return nil
	}
	out := new(KukuDeployment)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KukuDeployment) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuDeploymentList) DeepCopyInto(out *KukuDeploymentList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]KukuDeployment, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuDeploymentList.
func (in *KukuDeploymentList) DeepCopy() *KukuDeploymentList {
	if in == nil {
		return nil
	}
	out := new(KukuDeploymentList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KukuDeploymentList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuDeploymentSpec) DeepCopyInto(out *KukuDeploymentSpec) {
	*out = *in
	if in.Configuration != nil {
		in, out := &in.Configuration, &out.Configuration
		*out = new(KumoriConfiguration)
		(*in).DeepCopyInto(*out)
	}
	if in.Roles != nil {
		in, out := &in.Roles, &out.Roles
		*out = make([]KumoriRoleArrangement, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.SLAs != nil {
		in, out := &in.SLAs, &out.SLAs
		*out = make([]KumoriRoleSLA, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	in.ServiceSelector.DeepCopyInto(&out.ServiceSelector)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuDeploymentSpec.
func (in *KukuDeploymentSpec) DeepCopy() *KukuDeploymentSpec {
	if in == nil {
		return nil
	}
	out := new(KukuDeploymentSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuHttpInbound) DeepCopyInto(out *KukuHttpInbound) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuHttpInbound.
func (in *KukuHttpInbound) DeepCopy() *KukuHttpInbound {
	if in == nil {
		return nil
	}
	out := new(KukuHttpInbound)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KukuHttpInbound) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuHttpInboundList) DeepCopyInto(out *KukuHttpInboundList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]KukuHttpInbound, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuHttpInboundList.
func (in *KukuHttpInboundList) DeepCopy() *KukuHttpInboundList {
	if in == nil {
		return nil
	}
	out := new(KukuHttpInboundList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KukuHttpInboundList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuHttpInboundSpec) DeepCopyInto(out *KukuHttpInboundSpec) {
	*out = *in
	if in.Websocket != nil {
		in, out := &in.Websocket, &out.Websocket
		*out = new(bool)
		**out = **in
	}
	if in.VHosts != nil {
		in, out := &in.VHosts, &out.VHosts
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.Certs != nil {
		in, out := &in.Certs, &out.Certs
		*out = make([]Cert, len(*in))
		copy(*out, *in)
	}
	if in.Nodes != nil {
		in, out := &in.Nodes, &out.Nodes
		*out = make([]Node, len(*in))
		copy(*out, *in)
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuHttpInboundSpec.
func (in *KukuHttpInboundSpec) DeepCopy() *KukuHttpInboundSpec {
	if in == nil {
		return nil
	}
	out := new(KukuHttpInboundSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuLink) DeepCopyInto(out *KukuLink) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	out.Spec = in.Spec
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuLink.
func (in *KukuLink) DeepCopy() *KukuLink {
	if in == nil {
		return nil
	}
	out := new(KukuLink)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KukuLink) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuLinkElement) DeepCopyInto(out *KukuLinkElement) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuLinkElement.
func (in *KukuLinkElement) DeepCopy() *KukuLinkElement {
	if in == nil {
		return nil
	}
	out := new(KukuLinkElement)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuLinkList) DeepCopyInto(out *KukuLinkList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]KukuLink, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuLinkList.
func (in *KukuLinkList) DeepCopy() *KukuLinkList {
	if in == nil {
		return nil
	}
	out := new(KukuLinkList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KukuLinkList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuLinkSpec) DeepCopyInto(out *KukuLinkSpec) {
	*out = *in
	out.Element1 = in.Element1
	out.Element2 = in.Element2
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuLinkSpec.
func (in *KukuLinkSpec) DeepCopy() *KukuLinkSpec {
	if in == nil {
		return nil
	}
	out := new(KukuLinkSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuPersistentVolume) DeepCopyInto(out *KukuPersistentVolume) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuPersistentVolume.
func (in *KukuPersistentVolume) DeepCopy() *KukuPersistentVolume {
	if in == nil {
		return nil
	}
	out := new(KukuPersistentVolume)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KukuPersistentVolume) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuPersistentVolumeList) DeepCopyInto(out *KukuPersistentVolumeList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]KukuPersistentVolume, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuPersistentVolumeList.
func (in *KukuPersistentVolumeList) DeepCopy() *KukuPersistentVolumeList {
	if in == nil {
		return nil
	}
	out := new(KukuPersistentVolumeList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KukuPersistentVolumeList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuPersistentVolumeSpec) DeepCopyInto(out *KukuPersistentVolumeSpec) {
	*out = *in
	in.KukuVolumeSpec.DeepCopyInto(&out.KukuVolumeSpec)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuPersistentVolumeSpec.
func (in *KukuPersistentVolumeSpec) DeepCopy() *KukuPersistentVolumeSpec {
	if in == nil {
		return nil
	}
	out := new(KukuPersistentVolumeSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuService) DeepCopyInto(out *KukuService) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuService.
func (in *KukuService) DeepCopy() *KukuService {
	if in == nil {
		return nil
	}
	out := new(KukuService)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KukuService) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuServiceList) DeepCopyInto(out *KukuServiceList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]KukuService, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuServiceList.
func (in *KukuServiceList) DeepCopy() *KukuServiceList {
	if in == nil {
		return nil
	}
	out := new(KukuServiceList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KukuServiceList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuServiceSpec) DeepCopyInto(out *KukuServiceSpec) {
	*out = *in
	in.Channels.DeepCopyInto(&out.Channels)
	if in.Configuration != nil {
		in, out := &in.Configuration, &out.Configuration
		*out = new(KumoriConfigurationDescription)
		(*in).DeepCopyInto(*out)
	}
	if in.Connectors != nil {
		in, out := &in.Connectors, &out.Connectors
		*out = make([]KumoriConnector, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.Roles != nil {
		in, out := &in.Roles, &out.Roles
		*out = make([]KumoriRole, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuServiceSpec.
func (in *KukuServiceSpec) DeepCopy() *KukuServiceSpec {
	if in == nil {
		return nil
	}
	out := new(KukuServiceSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuVHost) DeepCopyInto(out *KukuVHost) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	out.Spec = in.Spec
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuVHost.
func (in *KukuVHost) DeepCopy() *KukuVHost {
	if in == nil {
		return nil
	}
	out := new(KukuVHost)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KukuVHost) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuVHostList) DeepCopyInto(out *KukuVHostList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]KukuVHost, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuVHostList.
func (in *KukuVHostList) DeepCopy() *KukuVHostList {
	if in == nil {
		return nil
	}
	out := new(KukuVHostList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KukuVHostList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuVHostSpec) DeepCopyInto(out *KukuVHostSpec) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuVHostSpec.
func (in *KukuVHostSpec) DeepCopy() *KukuVHostSpec {
	if in == nil {
		return nil
	}
	out := new(KukuVHostSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KukuVolumeSpec) DeepCopyInto(out *KukuVolumeSpec) {
	*out = *in
	if in.FileSystem != nil {
		in, out := &in.FileSystem, &out.FileSystem
		*out = new(FileSystemType)
		**out = **in
	}
	if in.MountPoint != nil {
		in, out := &in.MountPoint, &out.MountPoint
		*out = new(string)
		**out = **in
	}
	out.Size = in.Size.DeepCopy()
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KukuVolumeSpec.
func (in *KukuVolumeSpec) DeepCopy() *KukuVolumeSpec {
	if in == nil {
		return nil
	}
	out := new(KukuVolumeSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KumoriChannel) DeepCopyInto(out *KumoriChannel) {
	*out = *in
	if in.Port != nil {
		in, out := &in.Port, &out.Port
		*out = new(int32)
		**out = **in
	}
	if in.Children != nil {
		in, out := &in.Children, &out.Children
		*out = new([]string)
		if **in != nil {
			in, out := *in, *out
			*out = make([]string, len(*in))
			copy(*out, *in)
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KumoriChannel.
func (in *KumoriChannel) DeepCopy() *KumoriChannel {
	if in == nil {
		return nil
	}
	out := new(KumoriChannel)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KumoriChannels) DeepCopyInto(out *KumoriChannels) {
	*out = *in
	if in.Provides != nil {
		in, out := &in.Provides, &out.Provides
		*out = new([]KumoriChannel)
		if **in != nil {
			in, out := *in, *out
			*out = make([]KumoriChannel, len(*in))
			for i := range *in {
				(*in)[i].DeepCopyInto(&(*out)[i])
			}
		}
	}
	if in.Requires != nil {
		in, out := &in.Requires, &out.Requires
		*out = new([]KumoriChannel)
		if **in != nil {
			in, out := *in, *out
			*out = make([]KumoriChannel, len(*in))
			for i := range *in {
				(*in)[i].DeepCopyInto(&(*out)[i])
			}
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KumoriChannels.
func (in *KumoriChannels) DeepCopy() *KumoriChannels {
	if in == nil {
		return nil
	}
	out := new(KumoriChannels)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KumoriConfiguration) DeepCopyInto(out *KumoriConfiguration) {
	*out = *in
	if in.Parameters != nil {
		in, out := &in.Parameters, &out.Parameters
		*out = new(map[string]Unstructured)
		if **in != nil {
			in, out := *in, *out
			*out = make(map[string]Unstructured, len(*in))
			for key, val := range *in {
				(*out)[key] = *val.DeepCopy()
			}
		}
	}
	if in.Resources != nil {
		in, out := &in.Resources, &out.Resources
		*out = new(map[string]Unstructured)
		if **in != nil {
			in, out := *in, *out
			*out = make(map[string]Unstructured, len(*in))
			for key, val := range *in {
				(*out)[key] = *val.DeepCopy()
			}
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KumoriConfiguration.
func (in *KumoriConfiguration) DeepCopy() *KumoriConfiguration {
	if in == nil {
		return nil
	}
	out := new(KumoriConfiguration)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KumoriConfigurationDescription) DeepCopyInto(out *KumoriConfigurationDescription) {
	*out = *in
	if in.Parameters != nil {
		in, out := &in.Parameters, &out.Parameters
		*out = new([]KumoriParameterDescription)
		if **in != nil {
			in, out := *in, *out
			*out = make([]KumoriParameterDescription, len(*in))
			for i := range *in {
				(*in)[i].DeepCopyInto(&(*out)[i])
			}
		}
	}
	if in.Resources != nil {
		in, out := &in.Resources, &out.Resources
		*out = new([]KumoriResourceDescription)
		if **in != nil {
			in, out := *in, *out
			*out = make([]KumoriResourceDescription, len(*in))
			copy(*out, *in)
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KumoriConfigurationDescription.
func (in *KumoriConfigurationDescription) DeepCopy() *KumoriConfigurationDescription {
	if in == nil {
		return nil
	}
	out := new(KumoriConfigurationDescription)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KumoriConnector) DeepCopyInto(out *KumoriConnector) {
	*out = *in
	if in.Port != nil {
		in, out := &in.Port, &out.Port
		*out = new(int32)
		**out = **in
	}
	if in.Depended != nil {
		in, out := &in.Depended, &out.Depended
		*out = new([]KumoriEndpoint)
		if **in != nil {
			in, out := *in, *out
			*out = make([]KumoriEndpoint, len(*in))
			for i := range *in {
				(*in)[i].DeepCopyInto(&(*out)[i])
			}
		}
	}
	if in.Provided != nil {
		in, out := &in.Provided, &out.Provided
		*out = new([]KumoriEndpoint)
		if **in != nil {
			in, out := *in, *out
			*out = make([]KumoriEndpoint, len(*in))
			for i := range *in {
				(*in)[i].DeepCopyInto(&(*out)[i])
			}
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KumoriConnector.
func (in *KumoriConnector) DeepCopy() *KumoriConnector {
	if in == nil {
		return nil
	}
	out := new(KumoriConnector)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KumoriContainer) DeepCopyInto(out *KumoriContainer) {
	*out = *in
	if in.Cmd != nil {
		in, out := &in.Cmd, &out.Cmd
		*out = new([]string)
		if **in != nil {
			in, out := *in, *out
			*out = make([]string, len(*in))
			copy(*out, *in)
		}
	}
	if in.User != nil {
		in, out := &in.User, &out.User
		*out = new(Owner)
		(*in).DeepCopyInto(*out)
	}
	if in.Args != nil {
		in, out := &in.Args, &out.Args
		*out = new([]string)
		if **in != nil {
			in, out := *in, *out
			*out = make([]string, len(*in))
			copy(*out, *in)
		}
	}
	if in.FileSystem != nil {
		in, out := &in.FileSystem, &out.FileSystem
		*out = new([]FileSystemItem)
		if **in != nil {
			in, out := *in, *out
			*out = make([]FileSystemItem, len(*in))
			for i := range *in {
				(*in)[i].DeepCopyInto(&(*out)[i])
			}
		}
	}
	if in.Env != nil {
		in, out := &in.Env, &out.Env
		*out = new([]EnvItem)
		if **in != nil {
			in, out := *in, *out
			*out = make([]EnvItem, len(*in))
			copy(*out, *in)
		}
	}
	if in.Secret != nil {
		in, out := &in.Secret, &out.Secret
		*out = new(string)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KumoriContainer.
func (in *KumoriContainer) DeepCopy() *KumoriContainer {
	if in == nil {
		return nil
	}
	out := new(KumoriContainer)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KumoriEndpoint) DeepCopyInto(out *KumoriEndpoint) {
	*out = *in
	if in.Role != nil {
		in, out := &in.Role, &out.Role
		*out = new(string)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KumoriEndpoint.
func (in *KumoriEndpoint) DeepCopy() *KumoriEndpoint {
	if in == nil {
		return nil
	}
	out := new(KumoriEndpoint)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KumoriParameterDescription) DeepCopyInto(out *KumoriParameterDescription) {
	*out = *in
	if in.Default != nil {
		in, out := &in.Default, &out.Default
		*out = make([]byte, len(*in))
		copy(*out, *in)
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KumoriParameterDescription.
func (in *KumoriParameterDescription) DeepCopy() *KumoriParameterDescription {
	if in == nil {
		return nil
	}
	out := new(KumoriParameterDescription)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KumoriResourceDescription) DeepCopyInto(out *KumoriResourceDescription) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KumoriResourceDescription.
func (in *KumoriResourceDescription) DeepCopy() *KumoriResourceDescription {
	if in == nil {
		return nil
	}
	out := new(KumoriResourceDescription)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KumoriRole) DeepCopyInto(out *KumoriRole) {
	*out = *in
	in.ComponentSelector.DeepCopyInto(&out.ComponentSelector)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KumoriRole.
func (in *KumoriRole) DeepCopy() *KumoriRole {
	if in == nil {
		return nil
	}
	out := new(KumoriRole)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KumoriRoleArrangement) DeepCopyInto(out *KumoriRoleArrangement) {
	*out = *in
	if in.Maxinstances != nil {
		in, out := &in.Maxinstances, &out.Maxinstances
		*out = new(int32)
		**out = **in
	}
	if in.Mininstances != nil {
		in, out := &in.Mininstances, &out.Mininstances
		*out = new(int32)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KumoriRoleArrangement.
func (in *KumoriRoleArrangement) DeepCopy() *KumoriRoleArrangement {
	if in == nil {
		return nil
	}
	out := new(KumoriRoleArrangement)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KumoriRoleSLA) DeepCopyInto(out *KumoriRoleSLA) {
	*out = *in
	if in.Parameters != nil {
		in, out := &in.Parameters, &out.Parameters
		*out = (*in).DeepCopy()
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KumoriRoleSLA.
func (in *KumoriRoleSLA) DeepCopy() *KumoriRoleSLA {
	if in == nil {
		return nil
	}
	out := new(KumoriRoleSLA)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Mapping) DeepCopyInto(out *Mapping) {
	*out = *in
	if in.Env != nil {
		in, out := &in.Env, &out.Env
		*out = new(map[string]string)
		if **in != nil {
			in, out := *in, *out
			*out = make(map[string]string, len(*in))
			for key, val := range *in {
				(*out)[key] = val
			}
		}
	}
	if in.FileSystem != nil {
		in, out := &in.FileSystem, &out.FileSystem
		*out = new([]MountPoint)
		if **in != nil {
			in, out := *in, *out
			*out = make([]MountPoint, len(*in))
			for i := range *in {
				(*in)[i].DeepCopyInto(&(*out)[i])
			}
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Mapping.
func (in *Mapping) DeepCopy() *Mapping {
	if in == nil {
		return nil
	}
	out := new(Mapping)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *MountPoint) DeepCopyInto(out *MountPoint) {
	*out = *in
	if in.Data != nil {
		in, out := &in.Data, &out.Data
		*out = new(runtime.RawExtension)
		(*in).DeepCopyInto(*out)
	}
	if in.Format != nil {
		in, out := &in.Format, &out.Format
		*out = new(string)
		**out = **in
	}
	if in.Group != nil {
		in, out := &in.Group, &out.Group
		*out = new(int64)
		**out = **in
	}
	if in.Mode != nil {
		in, out := &in.Mode, &out.Mode
		*out = new(int32)
		**out = **in
	}
	if in.Size != nil {
		in, out := &in.Size, &out.Size
		*out = new(int32)
		**out = **in
	}
	if in.Unit != nil {
		in, out := &in.Unit, &out.Unit
		*out = new(string)
		**out = **in
	}
	if in.User != nil {
		in, out := &in.User, &out.User
		*out = new(int64)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MountPoint.
func (in *MountPoint) DeepCopy() *MountPoint {
	if in == nil {
		return nil
	}
	out := new(MountPoint)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Node) DeepCopyInto(out *Node) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Node.
func (in *Node) DeepCopy() *Node {
	if in == nil {
		return nil
	}
	out := new(Node)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Owner) DeepCopyInto(out *Owner) {
	*out = *in
	if in.UserID != nil {
		in, out := &in.UserID, &out.UserID
		*out = new(int64)
		**out = **in
	}
	if in.GroupID != nil {
		in, out := &in.GroupID, &out.GroupID
		*out = new(int64)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Owner.
func (in *Owner) DeepCopy() *Owner {
	if in == nil {
		return nil
	}
	out := new(Owner)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Permissions) DeepCopyInto(out *Permissions) {
	*out = *in
	if in.User != nil {
		in, out := &in.User, &out.User
		*out = new(Owner)
		(*in).DeepCopyInto(*out)
	}
	if in.Mode != nil {
		in, out := &in.Mode, &out.Mode
		*out = new(int32)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Permissions.
func (in *Permissions) DeepCopy() *Permissions {
	if in == nil {
		return nil
	}
	out := new(Permissions)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Profile) DeepCopyInto(out *Profile) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Profile.
func (in *Profile) DeepCopy() *Profile {
	if in == nil {
		return nil
	}
	out := new(Profile)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Qos) DeepCopyInto(out *Qos) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Qos.
func (in *Qos) DeepCopy() *Qos {
	if in == nil {
		return nil
	}
	out := new(Qos)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Reference) DeepCopyInto(out *Reference) {
	*out = *in
	if in.Version != nil {
		in, out := &in.Version, &out.Version
		*out = make(Version, len(*in))
		copy(*out, *in)
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Reference.
func (in *Reference) DeepCopy() *Reference {
	if in == nil {
		return nil
	}
	out := new(Reference)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Role) DeepCopyInto(out *Role) {
	*out = *in
	in.Component.DeepCopyInto(&out.Component)
	out.Size = in.Size
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Role.
func (in *Role) DeepCopy() *Role {
	if in == nil {
		return nil
	}
	out := new(Role)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *RoleSize) DeepCopyInto(out *RoleSize) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new RoleSize.
func (in *RoleSize) DeepCopy() *RoleSize {
	if in == nil {
		return nil
	}
	out := new(RoleSize)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in Scope) DeepCopyInto(out *Scope) {
	{
		in := &in
		*out = make(Scope, len(*in))
		copy(*out, *in)
		return
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Scope.
func (in Scope) DeepCopy() Scope {
	if in == nil {
		return nil
	}
	out := new(Scope)
	in.DeepCopyInto(out)
	return *out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Server) DeepCopyInto(out *Server) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Server.
func (in *Server) DeepCopy() *Server {
	if in == nil {
		return nil
	}
	out := new(Server)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Service) DeepCopyInto(out *Service) {
	*out = *in
	in.Element.DeepCopyInto(&out.Element)
	in.Description.DeepCopyInto(&out.Description)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Service.
func (in *Service) DeepCopy() *Service {
	if in == nil {
		return nil
	}
	out := new(Service)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ServiceDescription) DeepCopyInto(out *ServiceDescription) {
	*out = *in
	in.Config.DeepCopyInto(&out.Config)
	in.Srv.DeepCopyInto(&out.Srv)
	if in.Roles != nil {
		in, out := &in.Roles, &out.Roles
		*out = make(map[string]Role, len(*in))
		for key, val := range *in {
			(*out)[key] = *val.DeepCopy()
		}
	}
	if in.Connector != nil {
		in, out := &in.Connector, &out.Connector
		*out = make(map[string]ConnectorType, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
	if in.Links != nil {
		in, out := &in.Links, &out.Links
		*out = make(map[string]*runtime.RawExtension, len(*in))
		for key, val := range *in {
			var outVal *runtime.RawExtension
			if val == nil {
				(*out)[key] = nil
			} else {
				in, out := &val, &outVal
				*out = new(runtime.RawExtension)
				(*in).DeepCopyInto(*out)
			}
			(*out)[key] = outVal
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ServiceDescription.
func (in *ServiceDescription) DeepCopy() *ServiceDescription {
	if in == nil {
		return nil
	}
	out := new(ServiceDescription)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Srv) DeepCopyInto(out *Srv) {
	*out = *in
	if in.Duplex != nil {
		in, out := &in.Duplex, &out.Duplex
		*out = new(map[string]Duplex)
		if **in != nil {
			in, out := *in, *out
			*out = make(map[string]Duplex, len(*in))
			for key, val := range *in {
				(*out)[key] = val
			}
		}
	}
	if in.Clients != nil {
		in, out := &in.Clients, &out.Clients
		*out = new(map[string]Client)
		if **in != nil {
			in, out := *in, *out
			*out = make(map[string]Client, len(*in))
			for key, val := range *in {
				(*out)[key] = val
			}
		}
	}
	if in.Servers != nil {
		in, out := &in.Servers, &out.Servers
		*out = new(map[string]Server)
		if **in != nil {
			in, out := *in, *out
			*out = make(map[string]Server, len(*in))
			for key, val := range *in {
				(*out)[key] = val
			}
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Srv.
func (in *Srv) DeepCopy() *Srv {
	if in == nil {
		return nil
	}
	out := new(Srv)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ToChannel) DeepCopyInto(out *ToChannel) {
	*out = *in
	if in.To != nil {
		in, out := &in.To, &out.To
		*out = make(map[string]string, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ToChannel.
func (in *ToChannel) DeepCopy() *ToChannel {
	if in == nil {
		return nil
	}
	out := new(ToChannel)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ToConnector) DeepCopyInto(out *ToConnector) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ToConnector.
func (in *ToConnector) DeepCopy() *ToConnector {
	if in == nil {
		return nil
	}
	out := new(ToConnector)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in Unstructured) DeepCopyInto(out *Unstructured) {
	{
		in := &in
		clone := in.DeepCopy()
		*out = *clone
		return
	}
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *V3Deployment) DeepCopyInto(out *V3Deployment) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new V3Deployment.
func (in *V3Deployment) DeepCopy() *V3Deployment {
	if in == nil {
		return nil
	}
	out := new(V3Deployment)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *V3Deployment) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *V3DeploymentList) DeepCopyInto(out *V3DeploymentList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]V3Deployment, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new V3DeploymentList.
func (in *V3DeploymentList) DeepCopy() *V3DeploymentList {
	if in == nil {
		return nil
	}
	out := new(V3DeploymentList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *V3DeploymentList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in Version) DeepCopyInto(out *Version) {
	{
		in := &in
		*out = make(Version, len(*in))
		copy(*out, *in)
		return
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Version.
func (in Version) DeepCopy() Version {
	if in == nil {
		return nil
	}
	out := new(Version)
	in.DeepCopyInto(out)
	return *out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *VolumeRef) DeepCopyInto(out *VolumeRef) {
	*out = *in
	if in.Ref != nil {
		in, out := &in.Ref, &out.Ref
		*out = new(string)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new VolumeRef.
func (in *VolumeRef) DeepCopy() *VolumeRef {
	if in == nil {
		return nil
	}
	out := new(VolumeRef)
	in.DeepCopyInto(out)
	return out
}
